#include<gtk-2.0/gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include<cairo.h>
#include<glib.h>
#include<stdio.h>
#include<stdlib.h>
#include"mycolor.h"

gboolean button_press_event(GtkWidget* widget,GdkEventButton* event, gpointer user_data){
	int m_b_e=event->button;
	if(m_b_e==1){
		nowmain_plt = 1;
	}else if(m_b_e==3){
		nowmain_plt = 2;
	}
	
}

void change_color(){
	cairo_t *cr;
	if(nowmain_plt == 1){
		double sc;
	
		sc = (double)(mc_now_s)/255.0;
		cr = gdk_cairo_create(drawing_area1->window);
	
		cairo_set_source_rgb(cr,
							(double)mc_now_r/255.0*sc,
							(double)mc_now_g/255.0*sc,
							(double)mc_now_b/255.0*sc);
	/*	cairo_set_source_rgb(cr,
							((double)mc_now_r+(double)mc_now_s)/2.0/255.0,
							((double)mc_now_g+(double)mc_now_s)/2.0/255.0,
							((double)mc_now_b+(double)mc_now_s)/2.0/255.0);*/
	
		cairo_rectangle(cr,0,0,79,79);
	
		cairo_fill(cr);
	}else if(nowmain_plt == 2){
		double sc;
	
		sc = (double)(sc_now_s)/255.0;
		cr = gdk_cairo_create(drawing_area1->window);
	
		cairo_set_source_rgb(cr,
							(double)sc_now_r/255.0*sc,
							(double)sc_now_g/255.0*sc,
							(double)sc_now_b/255.0*sc);

	
		cairo_rectangle(cr,0,80,79,159);
	
		cairo_fill(cr);	
	}
	
}


static void
cb_r_value_changed(GtkScale *scale,gpointer user_data){
	g_print("value:%f\n",gtk_range_get_value(GTK_RANGE(scale) ));
	if(nowmain_plt == 1){
		mc_now_r = gtk_range_get_value( GTK_RANGE(scale) );
	}else if(nowmain_plt == 2){
		sc_now_r = gtk_range_get_value( GTK_RANGE(scale) );
	}
	change_color();
}

static void
cb_g_value_changed(GtkScale *scale,gpointer user_data){
	g_print("value:%f\n",gtk_range_get_value(GTK_RANGE(scale) ));
	if(nowmain_plt == 1){
		mc_now_g = gtk_range_get_value( GTK_RANGE(scale) );
	}else if(nowmain_plt == 2){
		sc_now_g = gtk_range_get_value( GTK_RANGE(scale) );
	}
	change_color();
}

static void
cb_b_value_changed(GtkScale *scale,gpointer user_data){
	g_print("value:%f\n",gtk_range_get_value(GTK_RANGE(scale) ));
	if(nowmain_plt == 1){
		mc_now_b = gtk_range_get_value( GTK_RANGE(scale) );
	}else if(nowmain_plt == 2){
		sc_now_b = gtk_range_get_value( GTK_RANGE(scale) );
	}
	mc_now_b = gtk_range_get_value( GTK_RANGE(scale) );
	change_color();
}

static void
cb_s_value_changed(GtkScale *scale,gpointer user_data){
	g_print("value:%f\n",gtk_range_get_value(GTK_RANGE(scale) ));
	if(nowmain_plt == 1){
		mc_now_s = gtk_range_get_value( GTK_RANGE(scale) );
	}else if(nowmain_plt == 2){
		sc_now_s = gtk_range_get_value( GTK_RANGE(scale) );
	}
	change_color();
}

gboolean Main_View_Draw(GtkWidget* widget,GdkEventExpose* event,gpointer data){
	return FALSE;
}

gint delete_event(GtkWidget* widget,GdkEvent* event, gpointer data){
	return FALSE;
}

void destroy(GtkWidget* widget,gpointer data){
}

void crate_mycolor(){
	char str[1024];
	GtkWidget* window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	gtk_window_set_title(GTK_WINDOW(window),"My Color");
	gtk_window_set_default_size(GTK_WINDOW(window),500,310);
	gtk_window_set_position(GTK_WINDOW(window),GTK_WIN_POS_CENTER_ALWAYS);

	gtk_signal_connect(GTK_OBJECT(window),"delete_event",GTK_SIGNAL_FUNC(delete_event),NULL);
	gtk_signal_connect(GTK_OBJECT(window),"destroy",GTK_SIGNAL_FUNC(destroy),NULL);


	//GtkWidget	*menubar;
	GtkWidget	*vbox;
	GtkWidget	*hbox;
	GtkWidget	*sclvbox;
	
	vbox=gtk_vbox_new(TRUE,0);
	gtk_container_add(GTK_CONTAINER(window),vbox);

	hbox=gtk_hbox_new(FALSE,0);
	gtk_box_pack_start(GTK_BOX(vbox),hbox,FALSE,FALSE,0);
	
	
	drawing_area1=gtk_drawing_area_new();
	gtk_widget_set_size_request(drawing_area1,80,160);
	gtk_box_pack_start(GTK_BOX(hbox),drawing_area1,FALSE,FALSE,0);


	sclvbox=gtk_vbox_new(TRUE,0);
	gtk_box_pack_start(GTK_BOX(hbox),sclvbox,TRUE,TRUE,0);
	//gtk_container_add(hbox,sclvbox);


	//------
	GtkWidget *r_scale = gtk_hscale_new_with_range(0,255,1);
	gtk_scale_set_draw_value(GTK_SCALE(r_scale)	, TRUE);
	gtk_scale_set_value_pos(GTK_SCALE(r_scale), GTK_POS_BOTTOM);
	gtk_range_set_value(r_scale,0);

	g_signal_connect(G_OBJECT(r_scale),"value-changed",G_CALLBACK(cb_r_value_changed),NULL);
	gtk_box_pack_start(GTK_BOX(sclvbox),r_scale ,TRUE,TRUE,0);

	//------
	GtkWidget *g_scale = gtk_hscale_new_with_range(0,255,1);
	gtk_scale_set_draw_value(GTK_SCALE(g_scale)	, TRUE);
	gtk_scale_set_value_pos(GTK_SCALE(g_scale), GTK_POS_BOTTOM);
	gtk_range_set_value(g_scale,0);

	g_signal_connect(G_OBJECT(g_scale),"value-changed",G_CALLBACK(cb_g_value_changed),NULL);
	gtk_box_pack_start(GTK_BOX(sclvbox),g_scale ,TRUE,TRUE,0);

	//------
	GtkWidget *b_scale = gtk_hscale_new_with_range(0,255,1);
	gtk_scale_set_draw_value(GTK_SCALE(b_scale)	, TRUE);
	gtk_scale_set_value_pos(GTK_SCALE(b_scale), GTK_POS_BOTTOM);
	gtk_range_set_value(b_scale,0);

	g_signal_connect(G_OBJECT(b_scale),"value-changed",G_CALLBACK(cb_b_value_changed),NULL);
	gtk_box_pack_start(GTK_BOX(sclvbox),b_scale ,TRUE,TRUE,0);

	//------
	GtkWidget *s_scale = gtk_hscale_new_with_range(0,255,1);
	gtk_scale_set_draw_value(GTK_SCALE(s_scale)	, TRUE);
	gtk_scale_set_value_pos(GTK_SCALE(s_scale), GTK_POS_BOTTOM);
	gtk_range_set_value(s_scale,0);

	g_signal_connect(G_OBJECT(s_scale),"value-changed",G_CALLBACK(cb_s_value_changed),NULL);
	gtk_box_pack_start(GTK_BOX(sclvbox),s_scale ,TRUE,TRUE,0);



	g_signal_connect(G_OBJECT(drawing_area1),"expose_event",G_CALLBACK(Main_View_Draw),NULL);

//	gtk_signal_connect(GTK_OBJECT(drawing_area1),"motion_notify_event",(GtkSignalFunc)motion_notify_event,NULL);
	gtk_signal_connect(GTK_OBJECT(drawing_area1),"button_press_event",(GtkSignalFunc)button_press_event,NULL);
//	gtk_signal_connect(GTK_OBJECT(drawing_area1),"button_release_event",(GtkSignalFunc)button_release_event,NULL);
	
/*	gtk_widget_set_events(drawing_area1,
					GDK_POINTER_MOTION_MASK |
					GDK_ENTER_NOTIFY_MASK | 
					GDK_BUTTON_PRESS_MASK|
					GDK_BUTTON_RELEASE_MASK);*/
gtk_widget_set_events(drawing_area1,
					GDK_POINTER_MOTION_MASK |
					GDK_BUTTON_PRESS_MASK);
				

/*	palet_area=gtk_drawing_area1_new();
	gtk_widget_set_size_request(palet_area,300,15);
	gtk_box_pack_start(GTK_BOX(vbox),palet_area,FALSE,FALSE,0);*/

	nowmain_plt = 1;
 


	gtk_widget_show_all(window);
}

